import * as i0 from '@angular/core';
import { InjectionToken, Injectable, inject, NgModule } from '@angular/core';
import * as i1 from '@angular/router';
import { NavigationEnd } from '@angular/router';

const _window = () => window;
const SCROLL_TOKEN = new InjectionToken('preserveScroll');
class WindowRef {
    get nativeWindow() {
        return _window();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: WindowRef, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: WindowRef });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: WindowRef, decorators: [{
            type: Injectable
        }] });
class BackButtonDisableModule {
    router;
    windowRef;
    preserveScroll = inject(SCROLL_TOKEN) || false;
    window;
    scrollX = 0;
    scrollY = 0;
    constructor(router, windowRef) {
        this.router = router;
        this.windowRef = windowRef;
        this.window = this.windowRef.nativeWindow;
        this.disableBackButton();
        this.addPopStateEventListener();
    }
    static forRoot(config) {
        return {
            ngModule: BackButtonDisableModule,
            providers: [
                {
                    provide: SCROLL_TOKEN,
                    useValue: config?.preserveScroll || false,
                }
            ]
        };
    }
    addPopStateEventListener() {
        this.window.addEventListener('popstate', () => {
            if (this.preserveScroll)
                this.getScrollCoordinates();
            this.window.history.pushState(null, null, null);
            if (this.preserveScroll)
                setTimeout(this.scrollToThePreviousPosition.bind(this));
        });
    }
    scrollToThePreviousPosition() {
        this.window.scrollTo(this.scrollX, this.scrollY);
    }
    getScrollCoordinates() {
        this.scrollX = this.window.scrollX;
        this.scrollY = this.window.scrollY;
    }
    disableBackButton() {
        this.window.history.pushState(null, null, null);
        this.router.events.subscribe(event => {
            if (event instanceof NavigationEnd) {
                this.window.history.pushState(null, null, null);
            }
            ;
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BackButtonDisableModule, deps: [{ token: i1.Router }, { token: WindowRef }], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: BackButtonDisableModule });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BackButtonDisableModule, providers: [WindowRef] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BackButtonDisableModule, decorators: [{
            type: NgModule,
            args: [{
                    providers: [WindowRef]
                }]
        }], ctorParameters: function () { return [{ type: i1.Router }, { type: WindowRef }]; } });

/**
 * Generated bundle index. Do not edit.
 */

export { BackButtonDisableModule, WindowRef };
//# sourceMappingURL=angular-disable-browser-back-button.mjs.map
